Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 736150 - dev-python/PyQt5-5.14.2-r1[bluetooth] w/ dev-qt/qtbluetooth-5.12.3 fails to build with error: ‘NetworkDevice’ is not a member of ‘QBluetoothDeviceInfo’
Summary: dev-python/PyQt5-5.14.2-r1[bluetooth] w/ dev-qt/qtbluetooth-5.12.3 fails to b...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Qt Bug Alias
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-08-06 16:10 UTC by Alex Orange
Modified: 2020-09-16 00:07 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge -pqv '=dev-python/PyQt5-5.14.2-r1::gentoo' (emerge-pqv,536 bytes, text/plain)
2020-08-06 16:11 UTC, Alex Orange
Details
build.log (build.log,220.04 KB, text/x-log)
2020-08-06 16:12 UTC, Alex Orange
Details
environment (environment,109.64 KB, text/plain)
2020-08-06 16:12 UTC, Alex Orange
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Alex Orange 2020-08-06 16:10:00 UTC
This seems to be #699386 with 5.14.2-r1.

Reproducible: Always

Steps to Reproduce:
1. emerge -avDuN --with-bdeps y world
2.
3.
Actual Results:  
Fails to build with:

x86_64-pc-linux-gnu-g++ -c -march=native -mtune=native -O3 -pipe -fno-exceptions -Wall -Wextra -D_REENTRANT -fPIC -DSIP_PROTECTED_IS_PUBLIC -Dprotected=public -DQT_NO_EXCEPTIONS -DQT_NO_DEBUG -DQT_PLUGIN -DQT_GUI_LIB -DQT_BLUETOOTH_LIB -DQT_CORE_LIB -I. -I. -isystem /usr/include/python3.7m -isystem /usr/include/qt5 -isystem /usr/include/qt5/QtGui -isystem /usr/include/qt5/QtBluetooth -isystem /usr/include/qt5/QtCore -I. -isystem /usr/include/libdrm -I/usr/lib64/qt5/mkspecs/linux-g++ -o sipQtBluetoothQBluetoothDeviceInfoServiceClasses.o sipQtBluetoothQBluetoothDeviceInfoServiceClasses.cpp
/var/tmp/portage/dev-python/PyQt5-5.14.2-r1/work/PyQt5-5.14.2-python3_7/QtBluetooth/sipQtBluetoothQBluetoothDeviceInfo.cpp: In function ‘PyObject* meth_QBluetoothDeviceInfo_setServiceUuids(PyObject*, PyObject*)’:
/var/tmp/portage/dev-python/PyQt5-5.14.2-r1/work/PyQt5-5.14.2-python3_7/QtBluetooth/sipQtBluetoothQBluetoothDeviceInfo.cpp:367:40: error: no matching function for call to ‘QBluetoothDeviceInfo::setServiceUuids(const QVector<QBluetoothUuid>&)’
  367 |             sipCpp->setServiceUuids(*a0);
      |                                        ^
In file included from /var/tmp/portage/dev-python/PyQt5-5.14.2-r1/work/PyQt5-5.14.2/sip/QtBluetooth/qbluetoothdeviceinfo.sip:28:
/usr/include/qt5/QtBluetooth/qbluetoothdeviceinfo.h:244:10: note: candidate: ‘void QBluetoothDeviceInfo::setServiceUuids(const QList<QBluetoothUuid>&, QBluetoothDeviceInfo::DataCompleteness)’
  244 |     void setServiceUuids(const QList<QBluetoothUuid> &uuids, DataCompleteness completeness);
      |          ^~~~~~~~~~~~~~~
/usr/include/qt5/QtBluetooth/qbluetoothdeviceinfo.h:244:10: note:   candidate expects 2 arguments, 1 provided
/var/tmp/portage/dev-python/PyQt5-5.14.2-r1/work/PyQt5-5.14.2-python3_7/QtBluetooth/sipQtBluetoothQBluetoothDeviceInfo.cpp: At global scope:
/var/tmp/portage/dev-python/PyQt5-5.14.2-r1/work/PyQt5-5.14.2-python3_7/QtBluetooth/sipQtBluetoothQBluetoothDeviceInfo.cpp:892:71: error: ‘NetworkDevice’ is not a member of ‘QBluetoothDeviceInfo’
  892 |     {sipName_NetworkDevice, static_cast<int>( ::QBluetoothDeviceInfo::NetworkDevice), 17},
      |                                                                       ^~~~~~~~~~~~~


Expected Results:  
Ebuild succeeds.

Portage 2.3.103 (python 3.6.10-final-0, default/linux/amd64/17.0/desktop, gcc-9.3.0, glibc-2.30-r8, 5.4.48-gentoo-x86_64 x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-5.4.48-gentoo-x86_64-x86_64-AMD_Opteron-tm-_Processor_4180-with-gentoo-2.6
KiB Mem:    16399716 total,  10641500 free
KiB Swap:   33554364 total,  33551028 free
Timestamp of repository gentoo: Wed, 05 Aug 2020 06:00:01 +0000
Head commit of repository gentoo: 4ab35d07d52f051c9f826df7f27bf51d9f856b7a
sh bash 5.0_p17
ld GNU ld (Gentoo 2.32 p2) 2.32.0
app-shells/bash:          5.0_p17::gentoo
dev-lang/perl:            5.30.3::gentoo
dev-lang/python:          2.7.18-r1::gentoo, 3.5.7::gentoo, 3.6.10-r1::gentoo, 3.7.8-r2::gentoo, 3.8.4-r1::gentoo
dev-util/cmake:           3.16.5::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/openrc:          0.42.1::gentoo
sys-apps/sandbox:         2.18::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.13.4-r2::gentoo, 1.15.1-r2::gentoo, 1.16.1-r1::gentoo
sys-devel/binutils:       2.32-r1::gentoo, 2.33.1-r1::gentoo
sys-devel/gcc:            6.4.0-r1::gentoo, 7.3.0-r3::gentoo, 8.3.0-r1::gentoo, 9.3.0-r1::gentoo
sys-devel/gcc-config:     2.3.1::gentoo
sys-devel/libtool:        2.4.6-r6::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 5.4-r1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.30-r8::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-metamanifest: yes
    sync-rsync-extra-opts: 
    sync-rsync-verify-max-age: 24
    sync-rsync-verify-jobs: 1

local_overlay
    location: /usr/local/portage
    masters: gentoo

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="@FREE AdobeFlash-10.1 PUEL"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -mtune=native -O3 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=native -mtune=native -O3 -pipe"
DISTDIR="/usr/portage/distfiles"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://gentoo.mirrors.easynews.com/linux/gentoo/ http://gentoo.osuosl.org/ http://ftp.ucsb.edu/pub/mirrors/linux/gentoo/ ftp://ftp.ucsb.edu/pub/mirrors/linux/gentoo/ ftp://mirror.its.uidaho.edu/gentoo/ http://mirror.its.uidaho.edu/pub/gentoo/ ftp://ftp.wallawalla.edu/pub/mirrors/ftp.gentoo.org"
LANG="en_US.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="en"
MAKEOPTS="-j7"
PKGDIR="/var/cache/binpkgs"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acpi alsa amd64 berkdb bluetooth branding bzip2 cairo cdda cdr cli crypt cups dbus dri dts dvd dvdr elogind emboss encode exif flac fortran gdbm gif gpm gtk iconv icu ipv6 jpeg lcms ldap libnotify libtirpc mad mng mp3 mp4 mpeg multilib ncurses nls nptl ogg opengl openmp pam pango pcre pdf png policykit ppds qt5 readline sdl seccomp spell split-usr ssl startup-notification svg tcpd tiff truetype udev udisks unicode upower usb vorbis wxwidgets x264 xattr xcb xml xv xvid zlib" ABI_X86="64" ADA_TARGET="gnat_2018" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="3dnow 3dnowext mmx mmxext popcnt sse sse2 sse3 sse4a" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-2 php7-3" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_7" PYTHON_TARGETS="python2_7 python3_7" RUBY_TARGETS="ruby25" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 1 Alex Orange 2020-08-06 16:11:58 UTC
Created attachment 653398 [details]
emerge -pqv '=dev-python/PyQt5-5.14.2-r1::gentoo'
Comment 2 Alex Orange 2020-08-06 16:12:23 UTC
Created attachment 653400 [details]
build.log
Comment 3 Alex Orange 2020-08-06 16:12:48 UTC
Created attachment 653402 [details]
environment
Comment 4 Alex Orange 2020-08-06 16:15:30 UTC
sip version:

# emerge -pv sip

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R    ] dev-python/sip-4.19.22-r1:0/12::gentoo  USE="-doc" PYTHON_TARGETS="python3_7 -python3_6 -python3_8 (-python3_9)" 0 KiB

Total: 1 package (1 reinstall), Size of downloads: 0 KiB

 * IMPORTANT: 9 news items need reading for repository 'gentoo'.
 * Use eselect news read to view new items.
Comment 5 Alex Orange 2020-08-07 05:52:06 UTC
Looking at the packages I had left to build I noticed qtbluetooth in the list. After emerging that PyQt5 worked.

These are the packages that would be merged, in order:

Calculating dependencies  ...... done!
[ebuild     U  ] dev-qt/qtbluetooth-5.14.2:5/5.14::gentoo [5.12.3:5/5.12::gentoo] USE="-debug -qml -test" 0 KiB

Total: 1 package (1 upgrade), Size of downloads: 0 KiB

To be clear, I'm not considering this fixed, just that I found a workaround.

Admittedly I'm not familiar w/ this ebuild, but is it possible the line:

QT_PV="5.12:5"

Should be changed to 5.14 or something like that?
Comment 6 Andreas Sturmlechner gentoo-dev 2020-08-07 14:48:03 UTC
In addition, similar to dev-qt/qtdeclarative it depends on private dev-qt/qtcore headers so should set a slot operator. That would have the side effect of hopefully scheduling it for upgrade earlier than PyQt5.
Comment 7 Davide Pesavento gentoo-dev 2020-09-16 00:07:00 UTC
(In reply to Alex Orange from comment #5)
> Admittedly I'm not familiar w/ this ebuild, but is it possible the line:
> 
> QT_PV="5.12:5"
> 
> Should be changed to 5.14 or something like that?

That's not strictly necessary. NetworkDevice is already enabled conditionally in PyQt5 only if Qt is recent enough. The problem here resulted from a mix of different versions of qtcore (5.14) and qtbluetooth (5.12).

That being said, I've raised the dep to 5.14 because there's no reason to bother supporting older versions of Qt that are no longer in tree.